// Verilog test fixture created from schematic C:\E\Documents\academic\classes\ECED2200\Labs\DigitalTrainer_Simple\io_connections.sch - Fri Jun 22 15:11:31 2012

`timescale 1ns / 1ps

module io_connections_io_connections_sch_tb();

// Inputs
   wire SW1;
   wire SW2;
   wire SW3;
   wire SW4;
   wire SW5;
   reg RST;
   reg CLK25KHZ = 0;
   reg CLK1HZ = 0;

// Output
   wire DISP7SEG_E;
   wire DISP7SEG_F;
   wire DISP7SEG_G;
   wire DISP7SEG_A;
   wire DISP7SEG_B;
   wire DISP7SEG_C;
   wire DISP7SEG_D;
   wire DISP7SEG_COM1;
   wire DISP7SEG_COM2;
   wire DISP7SEG_DOT;
   wire LED1;
   wire LED2;
   wire LED3;
   wire LED4;
   wire LED5;
   wire LED6;
   wire LED7;
   wire LED8;

// Bidirs

// Instantiate the UUT
   io_connections UUT (
		.DISP7SEG_E(DISP7SEG_E), 
		.DISP7SEG_F(DISP7SEG_F), 
		.DISP7SEG_G(DISP7SEG_G), 
		.SW1(SW1), 
		.SW2(SW2), 
		.SW3(SW3), 
		.SW4(SW4), 
		.SW5(SW5), 
		.DISP7SEG_A(DISP7SEG_A), 
		.DISP7SEG_B(DISP7SEG_B), 
		.DISP7SEG_C(DISP7SEG_C), 
		.DISP7SEG_D(DISP7SEG_D), 
		.DISP7SEG_COM1(DISP7SEG_COM1), 
		.DISP7SEG_COM2(DISP7SEG_COM2), 
		.DISP7SEG_DOT(DISP7SEG_DOT), 
		.LED1(LED1), 
		.LED2(LED2), 
		.LED3(LED3), 
		.LED4(LED4), 
		.LED5(LED5), 
		.LED6(LED6), 
		.LED7(LED7), 
		.LED8(LED8), 
		.RST(RST), 
		.CLK25KHZ(CLK25KHZ), 
		.CLK1HZ(CLK1HZ)
   );
	
	


// Initialize Inputs

	//We don't use accurate 8 MHz timing
	always begin
		CLK25KHZ = ~CLK25KHZ;
		#10;
	end
	
	//We don't use accurate 1 Hz timing - this clock is only 10x slower
	//in the simulator, in real life it's ~8000000x slower
	always begin
		CLK1HZ = ~CLK1HZ;
		#100;
	end
	
	initial begin
		RST = 0;
		#1;
		RST = 1;
		#10;
		@(posedge CLK25KHZ);
		#1;
		RST = 0;
	end
		
	reg [4:0] counter;

	always @(posedge CLK25KHZ or posedge RST) begin
		if (RST) begin
			counter = 5'b0;
		end else begin
			counter = counter + 5'b1;			
		end	
	end
	
	always @(posedge CLK25KHZ) begin
		if ((RST == 0) & (counter == 5'b11111)) begin
			#20;
			$finish;
		end
	end
	
	assign SW1 = counter[0];
	assign SW2 = counter[1];
	assign SW3 = counter[2];
	assign SW4 = counter[3];
	assign SW5 = counter[4];

endmodule
